/************************************************
* C_SHELL.C - a file management shell.  You can	*
* use this shell inside applications, or to		*
* build utilities ...							*
************************************************/

#include <process.h>
#include <stdio.h>
#include <string.h>
#include <dir.h>
#include "picklist.h"

void main(void)
	{
	char curr_path[MAXPATH], hold_path[MAXPATH];
	char drive[4],dir[MAXPATH],name[10],ext[6];
	char tmp[14], tmp2[30];
	int  curr_drive;

	curr_drive=getdisk();
	getcwd(curr_path,MAXPATH);
	strcpy(hold_path,curr_path);

	while (!pick_list(curr_path,"*.*",
								pick_list_dflt))
		{
		if (curr_path[0]==0)
			{
			printf("User abort\n");
			break;
			}
		fnsplit(curr_path,drive,dir,name,ext);
		strcpy(tmp,name);
		strcat(tmp,ext);
		if (strstr(ext,".BAK"))
			{
			printf("Erasing BACKUP file %s\n",
					name);
			unlink(tmp);
			}
		else if (strstr(ext,".BAT"))
			{
			printf("Executing BATCH file %s\n",
					name);
			system(name);
			}
		else if (strstr(ext,".EXE") ||
				 strstr(ext,".COM"))
			{
			printf("Running program %s\n",
					name);
			system(name);
			}
		else if (strstr(ext,".C ") ||
				 strstr(ext,".H ") ||
				 strstr(ext,".PRJ"))
			{
			printf("Running Turbo C for %s\n",tmp);
			sprintf(tmp2,"TC %s",tmp);
			system(tmp2);
			}
		else
			{
			printf("Bad file type %s\nExit shell",
					ext);
			break;
			}
		}
	setdisk(curr_drive);
	chdir(hold_path);
	}
